tests: Enhance retry test to cover failed reopen
[nbdkit/ericb.git] / tests / test-retry.sh
blob58c3f49227b35d25698c03f21018d4be0576b0ae
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2019 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires qemu-img --version
39 files="retry.img retry-count retry-open-count"
40 rm -f $files
41 cleanup_fn rm -f $files
43 touch retry-count retry-open-count
44 start_t=$SECONDS
46 # Create a custom plugin which will test retrying.
47 nbdkit -v -U - \
48 sh - \
49 --filter=retry retry-delay=1 \
50 --run 'qemu-img convert $nbd retry.img' <<'EOF'
51 #!/usr/bin/env bash
52 case "$1" in
53 open)
54 # Count how many times the connection is (re-)opened.
55 read i < retry-open-count
56 echo $((i+1)) > retry-open-count
58 pread)
59 # Fail 3 times then succeed.
60 read i < retry-count
61 ((i++))
62 echo $i > retry-count
63 if [ $i -le 3 ]; then
64 echo "EIO pread failed" >&2
65 exit 1
66 else
67 dd if=/dev/zero count=$3 iflag=count_bytes
71 get_size) echo 512 ;;
72 *) exit 2 ;;
73 esac
74 EOF
76 # In this test we should see 3 failures:
77 # pread FAILS
78 # retry and wait 1 seconds
79 # pread FAILS
80 # retry and wait 2 seconds
81 # pread FAILS
82 # retry and wait 4 seconds
83 # pread succeeds
85 # The minimum time for the test should be 1+2+4 = 7 seconds.
86 end_t=$SECONDS
87 if [ $((end_t - start_t)) -lt 7 ]; then
88 echo "$0: test ran too quickly"
89 exit 1
92 # Check the handle was opened 4 times (first open + one reopen for
93 # each retry).
94 read open_count < retry-open-count
95 if [ $open_count -ne 4 ]; then
96 echo "$0: open-count ($open_count) != 4"
97 exit 1